import groovyx.net.http.HTTPBuilder
import static groovyx.net.http.ContentType.URLENC

def http = new HTTPBuilder('http://nagios/nagios/cgi-bin/')
http.auth.basic 'nagiosadmin', 'stb1734aa!'

def postBody = [cmd_typ:'48', cmd_mod:'2', host:'bugs.urbancode.com']
def success = false

http.post(path: 'cmd.cgi', body:postBody, requestContentType: URLENC) { resp, xml ->
    def messageClass = xml.BODY[0].DIV[0].'@class'
    if (!messageClass || messageClass == '') throw new Exception('Could not parse command response!')
    success = messageClass == 'infoMessage'
    println "Success: ${success}"
    println xml.BODY[0].DIV[0].text()
}

def done = false

if (success) {
    while (!done) {
        http.get(path: 'extinfo.cgi', query:[type:'1', host:'bugs.urbancode.com']) { resp, xml ->
            def activeChecks = xml.depthFirst().find {
                it.'@class' == 'dataVar' && it.text() == 'Active Checks:'
            }
            if (!activeChecks) throw new Exception('Could not locate Active Checks status!')
            def activeChecksClass = activeChecks.parent().TD[1].DIV[0].'@class'
            if (!activeChecks || activeChecks == '') throw new Exception('Could not determine Active Checks status!')
            done = activeChecksClass == 'checksDISABLED'

            println "Disabled: $done"
            if (!done) sleep 2000
        }
    }
}

