import groovyx.net.http.HTTPBuilder
import static groovyx.net.http.ContentType.URLENC
import com.urbancode.air.AirPluginTool;

def apTool = new AirPluginTool(new File(args[0]), new File(args[1]));
def props = apTool.getStepProperties();

def url = props['url'];
while(url.endsWith('/')) {
    url = url.substring(0, url.length() - 1);
}
url = url + "/";

def username = props['username'];
def password = props['password'];
def hostGroup = props['hostgroup'];
def ticket = props['ticket'];

def backendUrl = url + "nagiosxi/backend/";

def statusCommandName = "gethoststatus";
def hostmembersCommandName='gethostgroupmembers';

def http = new HTTPBuilder(url);
http.auth.basic username, password

def commandId = 66

def postBody = [cmd_typ:commandId, cmd_mod:'2', hostgroup:hostGroup]
def success = false

println "Getting from url " + url +"nagios/cgi-bin/cmd.cgi with user:" + username;
http.get(path: 'nagios/cgi-bin/cmd.cgi', query:postBody) { resp, xml ->
    def messageClass = xml.BODY[0].DIV[0].'@class'
    if (!messageClass || messageClass == '') throw new Exception('Could not parse command response!')
    success = messageClass == 'infoMessage'
    println "Success: ${success}"
    println xml.BODY[0].DIV[0].text()
}

def done = false

if (success) {
    def backendHttp = new HTTPBuilder(backendUrl);
    def members = [];
    //first get the members to lookat
    backendHttp.get(path:'', query:[cmd:hostmembersCommandName, 'username':username,'ticket':ticket]) { resp, xml ->
        def thisHostGroup = xml.hostgroup.find { it.hostgroup_name == hostGroup };
        thisHostGroup.members[0].host.each { members << it.host_name.text() };
    }
    while (!done) {
        done = true;
        members.each { hostName ->
            backendHttp.get(path:'',query:[cmd:statusCommandName, 'username':username, 'ticket':ticket]) { resp, xml ->
                def notificationsEnabled = !(xml.hoststatus.find { it.name == hostName }.notifications_enabled[0].text() == "1");
                def curDone = notificationsEnabled;
    
                println "$hostName Disabled: $curDone"
                if (!curDone) {
                    done = false;
                }
            }
        }
        if (!done) sleep 2000
    }
}
else {
    throw new Exception("Didn't get a successful response from nagios");
}
