import groovyx.net.http.HTTPBuilder
import static groovyx.net.http.ContentType.URLENC
import com.urbancode.air.AirPluginTool;

def apTool = new AirPluginTool(new File(args[0]), new File(args[1]));
def props = apTool.getStepProperties();

def url = props['url'];
while(url.endsWith('/')) {
    url = url.substring(0, url.length() - 1);
}
url = url + "/";

def username = props['username'];
def password = props['password'];
def hostName = props['hostname'];
def ticket = props['ticket'];

def backendUrl = url + "nagiosxi/backend/";

def commandName = "gethoststatus";

def http = new HTTPBuilder(url);
http.auth.basic username, password

def commandId = 24

def postBody = [cmd_typ:commandId, cmd_mod:'2', host:hostName]
def success = false

println "Getting from url " + url +"nagios/cgi-bin/cmd.cgi with user : " + username;
http.get(path: 'nagios/cgi-bin/cmd.cgi', query:postBody) { resp, xml ->
    def messageClass = xml.BODY[0].DIV[0].'@class'
    if (!messageClass || messageClass == '') throw new Exception('Could not parse command response!')
    success = messageClass == 'infoMessage'
    println "Success: ${success}"
    println xml.BODY[0].DIV[0].text()
}

def done = false

if (success) {
    def backendHttp = new HTTPBuilder(backendUrl);
    while (!done) {
        backendHttp.get(path:'',query:[cmd:commandName, 'username':username, 'ticket':ticket]) { resp, xml ->
            def notificationsEnabled = !(xml.hoststatus.find { it.name == hostName }.notifications_enabled[0].text() == "0");
            done = notificationsEnabled;

            println "Enabled: $done"
            if (!done) sleep 2000
        }
    }
}
else {
    throw new Exception("Didn't get a successful response from nagios");
}
